// -*- C++ -*-
//
//  This file is part of WEEVILGEN.
//
//  Authors: See the file AUTHORS for full details.
//
//  Copyright (C) 2002-2004 University of Colorado
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
//  USA, or send email to serl@cs.colorado.edu.
//
// $Id: consumer.cc,v 1.1 2007-07-10 13:08:07 wolf Exp $
//
#include <cassert>
#include <cstring>
#include <string>
#include <weevil/weevil.h>

using namespace ssim;
using namespace std;
using namespace weevil;

/**
 * a simple sequential process class.  Consumer waits for signal
 * from producer
 */
class Consumer : public weevil::WeevilTProcess {
public:
  /**
   * sequential process, thus no implementation for "process_event" or "init"
   */
  virtual void main();
};

/**
 * method implementation
 */
void Consumer::main() {
    for(;;) {
        //
        // the Consumer simply waits for incoming events, and prints
        // their value
        //
        const E * x = (const E *)wait_for_event();
	char msg[256];
	sprintf( msg, "Get(%d)", x->x );
	workload_output( msg );
    }
}
