dnl -*- m4 -*-
dnl
dnl  This file is part of WEEVIL.
dnl
dnl  Authors: See the file AUTHORS for full details.
dnl
dnl  Copyright (C) 2002-2004 University of Colorado
dnl
dnl  This program is free software; you can redistribute it and/or
dnl  modify it under the terms of the GNU General Public License
dnl  as published by the Free Software Foundation; either version 2
dnl  of the License, or (at your option) any later version.
dnl
dnl  This program is distributed in the hope that it will be useful,
dnl  but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl  GNU General Public License for more details.
dnl
dnl  You should have received a copy of the GNU General Public License
dnl  along with this program; if not, write to the Free Software
dnl  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
dnl  USA, or send email to serl@cs.colorado.edu.
dnl
dnl $Id: exp_50_50_50.m4,v 1.1 2007-07-10 13:08:07 wolf Exp $
dnl
dnl workloads
dnl
WVL_SYS_Workload( `MyWorkload', `wkld_50_50_50.wkld', `WVL_SYS_Range(`br', 1, 150)')dnl
dnl
dnl --------------------- Experiment ---------------------------
dnl
define(`Actors', `WVL_SYS_Range(`D', 1, 150)')dnl
WVL_SYS_Experiment(`Exp_50_50_50', `MyWorkload', `Actors', `Bed0', `ApacheSquid', `CHMapS0, CHMapP0, CHMapP1, CHMapP2')dnl
dnl
dnl --------------------- TestBed ---------------------------
dnl
WVL_SYS_Testbed( `Bed0', `Local', `H0, H1, H2, H3', `', `')dnl
dnl
dnl --------------------- Host---------------------------
dnl
WVL_SYS_Host(`H0', `skagen.cs.colorado.edu', `ywang', `/bin/sh', `', `/scratch/weevil/skagentestroot', `Linux')dnl
WVL_SYS_Host(`H1', `canto.cs.colorado.edu', `ywang', `/bin/sh', `', `/scratch/weevil/cantotestroot', `FreeBSD')dnl
WVL_SYS_Host(`H2', `skylark.cs.colorado.edu', `ywang', `/bin/sh', `', `/scratch/weevil/skylarktestroot', `FreeBSD')dnl
WVL_SYS_Host(`H3', `serl-back.cs.colorado.edu', `ywang', `/bin/sh', `', `/scratch/weevil/serlbacktestroot', `FreeBSD')dnl
dnl
dnl --------------------- HostType---------------------------
dnl
WVL_SYS_HostType(`FreeBSD')dnl
WVL_SYS_HostType(`Linux')dnl
dnl
dnl --------------------- HostProp --------------------------
dnl
WVL_SYS_HostProp( `H0', `apacheRoot', `/scratch/SquidApache/Apache')dnl
WVL_SYS_HostProp( `H1', `squidRoot', `/scratch/Squid')dnl
WVL_SYS_HostProp( `H2', `squidRoot', `/scratch/Squid')dnl
WVL_SYS_HostProp( `H3', `squidRoot', `/scratch/SquidApache/Squid')dnl
dnl
dnl ----------------------- SUE -----------------------------
dnl
define(`ProxyRelations', `RP0P1, RP0P2, RP1P0, RP1P2, RP2P0, RP2P1')dnl
dnl
WVL_SYS_SUE( `ApacheSquid', `S0, P0, P1, P2', `ProxyRelations')dnl
dnl
dnl ----------------------- ComponentType -----------------------------
dnl
WVL_SYS_ComponentType(`ApacheServer', `ApacheServer_startScript', `ApacheServer_stopScript', ``include(`httpd.conf')'', dnl
`theCompPath/WVL_Experiment_Name`_'WVL_Component_ID`_error.log', dnl
theCompPath/WVL_Experiment_Name`_'WVL_Component_ID`_access.log'')dnl
WVL_SYS_ComponentType(`SquidProxy', `SquidProxy_startScript', `SquidProxy_stopScript', ``include(`squid.conf')'', dnl
`theCompPath/WVL_Experiment_Name`_'WVL_Component_ID`_access.log', dnl
theCompPath/WVL_Experiment_Name`_'WVL_Component_ID`_cache.log', dnl
theCompPath/WVL_Experiment_Name`_'WVL_Component_ID`_store.log'')dnl
dnl
dnl -----ApacheServer Start/Stop Script-----
dnl
define(`ApacheServer_startScript', dnl
`cd WVL_SYS_Echo(`WVL_Host_'WVL_SYS_Echo(theHost)`_apacheRoot')/bin
./apachectl -k start -f theCompPath/WVL_Experiment_Name`_'WVL_Component_ID.conf &')dnl
dnl
define(`ApacheServer_stopScript', dnl
`cd WVL_SYS_Echo(`WVL_Host_'WVL_SYS_Echo(theHost)`_apacheRoot')/bin
./apachectl -k stop -f theCompPath/WVL_Experiment_Name`_'WVL_Component_ID.conf')dnl
dnl
dnl -----SquidProxy Start/Stop Script-----
dnl
define(`SquidProxy_startScript', dnl
`rm -rf WVL_SYS_Echo(`WVL_Host_'WVL_SYS_Echo(theHost)`_squidRoot')/var/cache
WVL_SYS_Echo(`WVL_Host_'WVL_SYS_Echo(theHost)`_squidRoot')/sbin/squid -z
WVL_SYS_Echo(`WVL_Host_'WVL_SYS_Echo(theHost)`_squidRoot')/sbin/squid dnl
-N -d 1 -f theCompPath/WVL_Experiment_Name`_'WVL_Component_ID.conf &')dnl
dnl
define(`SquidProxy_stopScript', dnl
`read pid <theCompPath/WVL_SYS_Echo(WVL_Experiment_Name)`_'WVL_Component_ID.pid
echo $pid
kill $pid')dnl
dnl
dnl -----------------------Component-----------------------------
dnl
WVL_SYS_Component(`S0', `ApacheServer')dnl
define(`Proxies', `P0, P1, P2')dnl
WVL_SYS_Foreach(`i', `WVL_SYS_Component(i, `SquidProxy')', Proxies)dnl
dnl
dnl -----------------------ComponentProp-----------------------------
dnl
WVL_SYS_ComponentProp(`S0', `Port', 8080)dnl
WVL_SYS_Foreach(`i', `WVL_SYS_ComponentProp(i, `Port', 3128)', Proxies)dnl
WVL_SYS_Foreach(`i', `WVL_SYS_ComponentProp(i, `PeerPort', 3130)', Proxies)dnl
dnl
dnl -----------------------ComponentRelation-----------------------------
dnl
WVL_SYS_ComponentRelation(`RP0P1', `sibling', `P0', `P1')dnl
WVL_SYS_ComponentRelation(`RP0P2', `sibling', `P0', `P2')dnl
WVL_SYS_ComponentRelation(`RP1P0', `sibling', `P1', `P0')dnl
WVL_SYS_ComponentRelation(`RP1P2', `sibling', `P1', `P2')dnl
WVL_SYS_ComponentRelation(`RP2P0', `sibling', `P2', `P0')dnl
WVL_SYS_ComponentRelation(`RP2P1', `sibling', `P2', `P1')dnl
dnl
dnl -----------------------ComponentRelationProp-----------------------------
dnl
WVL_SYS_Foreach(`i', `WVL_SYS_ComponentRelationProp(i, `options', `no-digest')', ProxyRelations)dnl
dnl
dnl -----------------------ComponentOrder-----------------------------
dnl
dnl -----------------------ComponentHost-----------------------------
dnl
WVL_SYS_ComponentHost(`CHMapS0', `S0', `H0')dnl
WVL_SYS_ComponentHost(`CHMapP0', `P0', `H1')dnl
WVL_SYS_ComponentHost(`CHMapP1', `P1', `H2')dnl
WVL_SYS_ComponentHost(`CHMapP2', `P2', `H3')dnl
dnl
dnl -----------------------ActorProgram-----------------------------
dnl
WVL_SYS_ActorProgram(`DrProgram0', `Shell', `./actor', `apachesquidactor.sh', `ApacheSquidActor_args')dnl
dnl
define(`ApacheSquidActor_args', `dnl
WVL_SYS_Echo(`WVL_Host_'theHost`_squidRoot')/bin dnl
WVL_SYS_Echo(`WVL_Host_'theHost`_address') WVL_SYS_Echo(`WVL_Component_'theComponent`_Port') dnl
theActorPath')dnl
dnl
dnl -----------------------Actor-----------------------------
dnl
define(`ActorGroup1', `WVL_SYS_Range(`', 1, 50)')dnl
define(`ActorGroup2', `WVL_SYS_Range(`', 51, 100)')dnl
define(`ActorGroup3', `WVL_SYS_Range(`', 101, 150)')dnl
WVL_SYS_Foreach(`i', `WVL_SYS_Actor(`D'i, `br'i, `DrProgram0', `P0')', ActorGroup1)dnl
WVL_SYS_Foreach(`i', `WVL_SYS_Actor(`D'i, `br'i, `DrProgram0', `P1')', ActorGroup2)dnl
WVL_SYS_Foreach(`i', `WVL_SYS_Actor(`D'i, `br'i, `DrProgram0', `P2')', ActorGroup3)dnl
dnl
dnl -----------------------ActorProp-----------------------------
dnl
WVL_SYS_Foreach(`i', `WVL_SYS_ActorProp(i, `Port', `4324')', Actors)dnl
dnl
dnl -----------------------Workload Instantiation--------------------
dnl
define(`files', `WVL_SYS_Range(`', 1, 200)')dnl
WVL_SYS_Foreach(`i', `define(`file'i, dnl
`http://'`WVL_SYS_Echo(`WVL_Host_'WVL_SYS_Echo(`WVL_ComponentHost_'S0`_host')`_address')':WVL_SYS_Echo(`WVL_Component_'S0`_Port')`/test/'i`.txt')', files)dnl
dnl
