dnl -*- m4 -*-
dnl
dnl  This file is part of WEEVIL.
dnl
dnl  Authors: See the file AUTHORS for full details.
dnl
dnl  Copyright (C) 2002-2004 University of Colorado
dnl
dnl  This program is free software; you can redistribute it and/or
dnl  modify it under the terms of the GNU General Public License
dnl  as published by the Free Software Foundation; either version 2
dnl  of the License, or (at your option) any later version.
dnl
dnl  This program is distributed in the hope that it will be useful,
dnl  but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl  GNU General Public License for more details.
dnl
dnl  You should have received a copy of the GNU General Public License
dnl  along with this program; if not, write to the Free Software
dnl  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
dnl  USA, or send email to serl@cs.colorado.edu.
dnl
dnl $Id: chord_100.m4,v 1.1 2007-07-10 13:08:09 wolf Exp $
dnl
dnl workloads
dnl
WVL_SYS_Workload( `MyWorkload', `wkld_100.wkld', `WVL_SYS_Range(`U', 0, 99)')dnl
dnl
define(`ARange', `WVL_SYS_Range(`', 0, 99)')dnl
define(`HRange', `WVL_SYS_Range(`', 0, 51)')dnl
define(`CRange', `WVL_SYS_Range(`', 0, 99)')dnl
dnl
dnl --------------------- Experiment ---------------------------
dnl
define(`Actors', `WVL_SYS_Range(`A', 0, 99)')dnl
WVL_SYS_Experiment(`Chord_load_100', `MyWorkload', `Actors', `Bed0', `Chord', `WVL_SYS_Range(`CHMapN', 0, 99)', `N', `30', `', `2100')dnl
dnl
dnl --------------------- TestBed ---------------------------
dnl
WVL_SYS_Testbed( `Bed0', `WVL_SYS_Range(`H', 0, 51)')dnl
dnl
dnl --------------------- Host---------------------------
dnl
WVL_SYS_Foreach(`i', `WVL_SYS_Host(`H'i, `node'i`.localnet.Weevil.emulab.net', `ywang', `/bin/sh', `/usr/java/j2sdk1.4.2_07/bin/java', `/tmp/weevil', `Linux')', HRange)dnl
dnl
dnl --------------------- HostType---------------------------
dnl
WVL_SYS_HostType(`Linux')dnl
dnl
dnl --------------------- HostProp --------------------------
dnl
WVL_SYS_Foreach(`i', `WVL_SYS_HostProp(`H'i, `alias', `node'i)', HRange)dnl
WVL_SYS_Foreach(`i', `WVL_SYS_HostProp(`H'i, `ip', `10.1.1.'eval(i+2))', HRange)dnl
dnl
dnl ----------------------- SUE -----------------------------
dnl
WVL_SYS_SUE( `Chord', `WVL_SYS_Range(`N', 0, 99)', `WVL_SYS_Range(`N0N', 0, 99)',  `order1', `PreStartComps0')dnl
dnl
dnl ----------------------- SUENego -----------------------------
dnl
dnl ----------------------- ComponentType -----------------------------
dnl
WVL_SYS_ComponentType(`ChordNode', `Chord_startScript', `Chord_stopScript', `ChordNode_args', `', dnl
`WVL_Experiment_Name`_'WVL_Component_ID`.log'')dnl
dnl
dnl -----Chord Start/Stop Script-----
dnl
define(`Chord_startScript', dnl
`theSoftwarePath/adbd -S theCompPath/db -d theCompPath/db_file &
echo $! >theCompPath/WVL_SYS_Echo(WVL_Experiment_Name)`_'WVL_Component_ID`_1.pid'
sleep 2
theSoftwarePath/lsd -d theCompPath/db -S theCompPath/sock -C theCompPath/ctlsock -L theCompPath/WVL_SYS_Echo(WVL_Experiment_Name)`_'WVL_Component_ID.log -T theCompPath/trace -l WVL_SYS_Echo(`WVL_Host_'theHost`_ip') -j $`'1:$`'2 -p WVL_SYS_Echo(`WVL_Component_'WVL_Component_ID`_ListenPort') &')dnl
dnl
define(`Chord_stopScript', dnl
`read adbdpid <theCompPath/WVL_SYS_Echo(WVL_Experiment_Name)`_'WVL_Component_ID`_1.pid'
kill $adbdpid
read pid <theCompPath/WVL_SYS_Echo(WVL_Experiment_Name)`_'WVL_Component_ID.pid
echo $pid
kill $pid')dnl
dnl
define(`ChordNode_args', `dnl
define(`bs_comp', WVL_SYS_Echo(`WVL_ComponentRelation_'WVL_Component_ID`_bootstrap'))dnl
define(`bs_host', WVL_SYS_Echo(`WVL_ComponentHost_'WVL_SYS_Echo(bs_comp)`_host'))dnl
define(`bs_address', WVL_SYS_Echo(`WVL_Host_'WVL_SYS_Echo(bs_host)`_alias'))dnl
bs_address WVL_SYS_Echo(`WVL_Component_'bs_comp`_ListenPort')')dnl
dnl
dnl -----------------------ComponentHostType--------------------------
dnl
WVL_SYS_ComponentHostType( `ChordNode', `Linux', `/scratch/sfsnet2006/chordbuild/bin1')dnl
dnl
dnl -----------------------Component-----------------------------
dnl
WVL_SYS_Foreach(`i', `WVL_SYS_Component(`N'i, `ChordNode')', CRange)dnl
dnl
dnl -----------------------ComponentProp-----------------------------
dnl
WVL_SYS_Foreach(`i', `WVL_SYS_ComponentProp(`N'i, `ListenPort', eval(27882+(i/50*2)))', CRange)dnl
dnl
dnl -----------------------ComponentRelation-----------------------------
dnl
WVL_SYS_Foreach(`i', `WVL_SYS_ComponentRelation(`N0N'i, `bootstrap', `N'i, `N0')', CRange)dnl
dnl
dnl -----------------------ComponentRelationProp-----------------------------
dnl
dnl
dnl -----------------------Pre Start Component-----------------------------
dnl
WVL_SYS_ComponentPreStart(`PreStartComps0', `WVL_SYS_Range(`N', 0, 99)')dnl
dnl
dnl -----------------------ComponentOrder-----------------------------
dnl
define(`last1', `N99, 1')dnl
WVL_SYS_ComponentOrder(`order1', dnl
`WVL_SYS_Foreach(`i', ``N'i, 1, ', WVL_SYS_Range(`', 0, 98))last1')dnl
dnl
dnl -----------------------ComponentHost-----------------------------
dnl
WVL_SYS_Foreach(`i', `WVL_SYS_ComponentHost(`CHMapN'i, `N'i, `H'eval(i%50))', CRange)dnl
dnl
dnl -----------------------ActorProgram-----------------------------
dnl
WVL_SYS_ActorProgram(`DrProgram0', `Shell', `./actor', `chordactor.sh', `', `', `WVL_Experiment_Name`_'WVL_Actor_ID`.log'')dnl
dnl
dnl -----------------------Actor-----------------------------
dnl
WVL_SYS_Foreach(`i', `WVL_SYS_Actor(`A'i, `U'i, `DrProgram0', `N'i, `files/U'i)', ARange)dnl
dnl
dnl -----------------------ActorProp-----------------------------
dnl
dnl -----------------------Workload Instantiation--------------------
dnl
dnl define(`frange', `WVL_SYS_Range(`', 1, 2000)')dnl
dnl WVL_SYS_Foreach(`i', `define(`f'i, `WVL_SYS_Echo(theActorPath)'`/file'i)', frange)dnl