dnl -*- m4 -*-
dnl
dnl  This file is part of WEEVIL.
dnl
dnl  Authors: See the file AUTHORS for full details.
dnl
dnl  Copyright (C) 2002-2004 University of Colorado
dnl
dnl  This program is free software; you can redistribute it and/or
dnl  modify it under the terms of the GNU General Public License
dnl  as published by the Free Software Foundation; either version 2
dnl  of the License, or (at your option) any later version.
dnl
dnl  This program is distributed in the hope that it will be useful,
dnl  but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl  GNU General Public License for more details.
dnl
dnl  You should have received a copy of the GNU General Public License
dnl  along with this program; if not, write to the Free Software
dnl  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
dnl  USA, or send email to serl@cs.colorado.edu.
dnl
dnl $Id: exp_siena.m4,v 1.1 2007-07-10 13:08:10 wolf Exp $
dnl
dnl workloads
dnl
dnl
dnl --------------------- Experiment ---------------------------
dnl
dnl --- define number of Siena Servers
define(`SServersNumber', 2)dnl
define(`SServersRange', `WVL_SYS_Range(`', 1, SServersNumber)')dnl
define(`SServers', `WVL_SYS_Range(`SServer', 1, SServersNumber)')dnl
dnl --- define number of Siena Clients
define(`SClientsNumber', 2)dnl
dnl --- define actors for clients 
define(`SClientsRange', `WVL_SYS_Range(`', 1, SClientsNumber)')dnl
define(`SClientActors', `WVL_SYS_Range(`SCA', 1, SClientsNumber)')dnl
dnl --- define IDs for clients 
define(`SClients', `WVL_SYS_Range(`SClient', 1, SClientsNumber)')dnl
dnl
dnl SIGNATURE: WVL_SYS_Experiment(`id', `workload', `actors', `testbed', `SUE', `componentHostsMapping')dnl
dnl
WVL_SYS_Experiment(`Exp_Siena', `MyWorkload', `SClientActors', `Bed0', `SienaDVDRP',dnl
`WVL_SYS_Range(`Map_SS', 1, SServersNumber), WVL_SYS_Range(`Map_SC', 1, SClientsNumber)',,1)dnl
dnl
dnl
dnl --------------------- Workload ---------------------------
dnl
WVL_SYS_Workload( `MyWorkload', `exp_siena.wkld', `SClientActors')dnl
dnl
dnl --------------------- TestBed ---------------------------
dnl
dnl SIGNATURE: WVL_SYS_Testbed( ID, Host List)dnl
dnl
WVL_SYS_Testbed( `Bed0', `H0, VH0')dnl
dnl
dnl --------------------- Host---------------------------
dnl
dnl SIGNATURE: WVL_SYS_Host(`id', `address', `account', `shell', `java', `weevilroot (workspace)', `hosttype')dnl
dnl
WVL_SYS_Host(`H0', `localhost', `tof', `/bin/sh', `/opt/java/bin/java', `/home/tof/temp/weevil-tests/demo-run', `Linux')dnl
WVL_SYS_Host(`VH0', `192.168.161.130', `toyuser', `/bin/sh', `/usr/bin/java', `/home/toyuser/demo-run', `Linux')dnl
dnl
dnl --------------------- HostType---------------------------
dnl
WVL_SYS_HostType(`Linux')dnl
dnl
dnl --------------------- HostProp --------------------------
dnl
dnl ----------------------- SUE -----------------------------
dnl
dnl SIGNATURE: WVL_SYS_SUE( `id', `components', `relations', `order', `prestart')
dnl
WVL_SYS_SUE( `SienaDVDRP', `SServer1, SServer2, SClient1, SClient2', `', `Order', `PreStartComponents')dnl
dnl
dnl ----------------------- ComponentType -----------------------------
dnl
dnl SIGNATURE: WVL_SYS_ComponentType(`id', `startScript', `stopScript', `startArgs', `config', `logs')
dnl
WVL_SYS_ComponentType(`SienaServer', `:', `:', `', `', `theCompPath/toffoloTest.log')dnl
WVL_SYS_ComponentType(`SienaClient', `:', `:', `', `', `')dnl
dnl
dnl -----------------------Component-----------------------------
dnl
WVL_SYS_Foreach(`i', `WVL_SYS_Component(`SServer'i, `SienaServer')', SServersRange)dnl
WVL_SYS_Foreach(`i', `WVL_SYS_Component(`SClient'i, `SienaClient')', SClientsRange)dnl
dnl
dnl -----------------------ComponentProp-----------------------------
dnl
dnl
dnl -----------------------ComponentRelation-----------------------------
dnl
dnl
dnl -----------------------ComponentRelationProp-----------------------------
dnl
dnl -----------------------Pre Start Component-----------------------------
dnl
WVL_SYS_ComponentPreStart(`PreStartComponents', `SServer1, SServer2')dnl
dnl
dnl -----------------------ComponentOrder-----------------------------
dnl
WVL_SYS_ComponentOrder(`Order', `SServer1, 0, SServer2, 50')dnl
dnl -----------------------ComponentHost-----------------------------
dnl
WVL_SYS_Foreach(`i', `WVL_SYS_ComponentHost(`Map_SS'i, `SServer'i, `VH0')', SServersRange)dnl
WVL_SYS_Foreach(`i', `WVL_SYS_ComponentHost(`Map_SC'i, `SClient'i, `H0')', SClientsRange)dnl
dnl
dnl -----------------------ActorProgram-----------------------------
dnl
dnl  SIGNATURE: WVL_SYS_ActorProgram(`id', `style: Java | shell', `binaryDistrDir', `program', `argument', `classPath:classPath', `logs', `receiveProgram: program that receives messages from other actors')dnl
WVL_SYS_ActorProgram(`SClientActorProgram', `Java', `./actor', `SienaClientActor', `', `theActorPath/siena-actors.jar', `WVL_Experiment_Name`_'WVL_Actor_ID`.log'')dnl
dnl
dnl
dnl -----------------------Actor-----------------------------
dnl
dnl SIGNATURE: WVL_SYS_Actor(id, workloadProcess id, actorProgram, component, dir, props)
WVL_SYS_Foreach(`i', `WVL_SYS_Actor(`SCA'i, `C'i, `SClientActorProgram', `SClient'i,`',)', SClientsRange)dnl
dnl
dnl -----------------------ActorProp-----------------------------
dnl
dnl WVL_SYS_Foreach(`i', `WVL_SYS_ActorProp(i, `dir', `dir'i)', Actors)dnl
dnl
dnl -----------------------Workload Instantiation--------------------
dnl



