dnl -*- m4 -*-
dnl
dnl  This file is part of WEEVIL.
dnl
dnl  Authors: See the file AUTHORS for full details.
dnl
dnl  Copyright (C) 2002-2004 University of Colorado
dnl
dnl  This program is free software; you can redistribute it and/or
dnl  modify it under the terms of the GNU General Public License
dnl  as published by the Free Software Foundation; either version 2
dnl  of the License, or (at your option) any later version.
dnl
dnl  This program is distributed in the hope that it will be useful,
dnl  but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl  GNU General Public License for more details.
dnl
dnl  You should have received a copy of the GNU General Public License
dnl  along with this program; if not, write to the Free Software
dnl  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
dnl  USA, or send email to serl@cs.colorado.edu.
dnl
dnl $Id: experiment.m4,v 1.1 2007-07-10 13:08:10 wolf Exp $
dnl
dnl ===================== Experiment ======================
dnl
dnl SIGNATURE: WVL_SYS_Experiment(`id', `workload', `actors', `testbed', `SUE', `componentHostsMapping', `clean workspace', `parallel', `monitor', `timeout(sec)')dnl
dnl
WVL_SYS_Experiment(`Exp0', `MyWorkload', `D0, D1, D2, LL', `Bed0', `Siena', `CHMap0, CHMap1, CHMap2',`N',`5',,`300')dnl
dnl
dnl ===================== Workload ======================
dnl
WVL_SYS_Workload(`MyWorkload', `exp_siena.wkld', `C1, C2, C3')dnl
dnl
dnl ===================== Testbed Conceptual Model Configuration ====================
dnl
dnl -- TestBed --
dnl
WVL_SYS_Testbed( `Bed0', `H0, VH0')dnl
dnl
dnl -- Host --
dnl
WVL_SYS_Host(`H0', `192.168.161.1', `tof', `/bin/sh', `/opt/java/bin/java', `/home/tof/temp/weevil-tests/demo-run', `Linux')dnl
WVL_SYS_Host(`VH0', `192.168.161.130', `toyuser', `/bin/sh', `/usr/bin/java', `/home/toyuser/demo-run', `Linux')dnl
dnl
dnl -- HostType --
dnl
WVL_SYS_HostType(`Linux')dnl
dnl
dnl -- HostProp --
dnl
dnl
dnl ======================= SUE Conceptual Model Configuration =======================
dnl
dnl -- SUE --
dnl
WVL_SYS_SUE( `Siena', `S0, S1, S2', `R10, R20', `Order', `PreStartComponents')dnl
dnl
dnl -- ComponentType --
dnl
WVL_SYS_ComponentType(`SienaDVDRPServer', `SienaDVDRPServer_startScript', `SienaDVDRPServer_stopScript', `', `', dnl
`WVL_SYS_Echo(WVL_Experiment_Name)`_'WVL_Component_ID.log, dnl
WVL_SYS_Echo(WVL_Experiment_Name)`_'WVL_Component_ID.err')dnl
dnl
dnl - SienaServer Start/Stop Script -
dnl
dnl ----- Here we prepare the start script  using properties and relationships set for each component
define(`SienaDVDRPServer_startScript', dnl
`WVL_SYS_Echo(`WVL_Host_'WVL_SYS_Echo(theHost)`_java') -classpath dnl
theSoftwarePath/siena-plastic-0.1.jar dnl
siena.StartDVDRPServer -id WVL_Component_ID -WVL_SYS_Echo(`WVL_Component_'WVL_Component_ID`_Protocol') \
-port WVL_SYS_Echo(`WVL_Component_'WVL_Component_ID`_Port') -host WVL_SYS_Echo(`WVL_Host_'theHost`_address') \
 -log theCompPath/WVL_SYS_Echo(WVL_Experiment_Name)`_'WVL_Component_ID.log -err theCompPath/WVL_SYS_Echo(WVL_Experiment_Name)`_'WVL_Component_ID.err &')dnl
dnl
define(`SienaDVDRPServer_stopScript', dnl
`read pid <theCompPath/WVL_SYS_Echo(WVL_Experiment_Name)`_'WVL_Component_ID.pid
echo $pid
kill $pid')dnl
dnl
dnl -- Component --
dnl
WVL_SYS_Component(`S0', `SienaDVDRPServer')dnl
WVL_SYS_Component(`S1', `SienaDVDRPServer')dnl
WVL_SYS_Component(`S2', `SienaDVDRPServer')dnl
dnl
dnl -- ComponentProp --
dnl
WVL_SYS_ComponentProp(`S0', `Port', 4321)dnl
WVL_SYS_ComponentProp(`S1', `Port', 8088)dnl
WVL_SYS_ComponentProp(`S2', `Port', 6543)dnl
WVL_SYS_ComponentProp(`S0', `Protocol', `tcp')dnl
WVL_SYS_ComponentProp(`S1', `Protocol', `tcp')dnl
WVL_SYS_ComponentProp(`S2', `Protocol', `tcp')dnl
dnl
dnl -- ComponentRelation --
dnl
WVL_SYS_ComponentRelation(`R10', `Neighbor', `S1', `S0')dnl
WVL_SYS_ComponentRelation(`R20', `Neighbor', `S2', `S0')dnl
dnl
dnl -- ComponentOrder --
dnl
WVL_SYS_ComponentOrder(`Order', `S0, 3, S1, 0, S2, 30')dnl
dnl -----------------------Pre Start Component-----------------------------
dnl
WVL_SYS_ComponentPreStart(`PreStartComponents', `S0, S1, S2')dnl
dnl
dnl ===================== Mappings(SUE-Testbed) ====================
dnl
dnl -- ComponentHost --
dnl
WVL_SYS_ComponentHost(`CHMap0', `S0', `H0')dnl
WVL_SYS_ComponentHost(`CHMap1', `S1', `VH0')dnl
WVL_SYS_ComponentHost(`CHMap2', `S2', `H0')dnl
dnl
dnl -- ComponentHostType --
dnl
WVL_SYS_ComponentHostType( `SienaDVDRPServer', `Linux', `/home/tof/apps/weevil-experiments/siena-dvdrp/binaries')dnl
dnl
dnl ===================== Mappings(SUE-Actor) ====================
dnl
dnl -- ActorProgram to trigger subsccriptions and --
dnl
WVL_SYS_ActorProgram(`DrProgram', `Java', `./actor', `siena.SienaActor', `SienaActor_args', `SienaActor_classpath')dnl
dnl
define(`SienaActor_args', `WVL_SYS_Echo(`WVL_Component_'theComponent`_Protocol') dnl
WVL_SYS_Echo(`WVL_Host_'theHost`_address') WVL_SYS_Echo(`WVL_Component_'theComponent`_Port') dnl
WVL_SYS_Echo(`WVL_Actor_'WVL_Actor_ID`_Port')')dnl
dnl
define(`SienaActor_classpath', `theSoftwarePath/siena-plastic-0.1.jar')dnl
dnl
dnl -- ActorProgram to dynamically link servers
WVL_SYS_ActorProgram(`LinkProgram', `Java', `./actor', `siena.LinkActor', `LinkActor_args', `LinkActor_classpath')dnl
dnl
dnl TOF: fix workaround for this cycle: WVL_SUE_Siena_components ("Siena" should not be there)
define(`LinkActor_args', WVL_SYS_Foreach(`i', computeLinkArgs(i, `WVL_SYS_Echo(`WVL_ComponentHost_'i`_host')'), WVL_SUE_Siena_components))dnl
define(`computeLinkArgs', `WVL_SYS_Echo($1) WVL_SYS_Echo(`WVL_Component_'$1`_Protocol') dnl
`WVL_SYS_Echo(`WVL_Host_'$2`_address')' WVL_SYS_Echo(`WVL_Component_'$1`_Port') ')dnl
dnl 
dnl
define(`LinkActor_classpath', `theSoftwarePath/siena-plastic-0.1.jar')dnl
dnl
dnl -- Actor --
dnl
dnl SIGNATURE: WVL_SYS_Actor(id, workloadProcess id, actorProgram, component, dir, props)
WVL_SYS_Actor(`D0', `C0', `DrProgram', `S0')dnl
WVL_SYS_Actor(`D1', `C1', `DrProgram', `S1')dnl
WVL_SYS_Actor(`D2', `C2', `DrProgram', `S2')dnl
WVL_SYS_Actor(`LL', `CL', `LinkProgram', `S0')dnl
dnl
dnl
dnl -- ActorProp --
dnl
WVL_SYS_ActorProp(`D0', `Port', `4322')dnl
WVL_SYS_ActorProp(`D1', `Port', `5433')dnl
WVL_SYS_ActorProp(`D2', `Port', `6544')dnl
dnl
