dnl -*- m4 -*-
dnl
dnl  This file is part of WEEVIL.
dnl
dnl  Authors: See the file AUTHORS for full details.
dnl
dnl  Copyright (C) 2002-2004 University of Colorado
dnl
dnl  This program is free software; you can redistribute it and/or
dnl  modify it under the terms of the GNU General Public License
dnl  as published by the Free Software Foundation; either version 2
dnl  of the License, or (at your option) any later version.
dnl
dnl  This program is distributed in the hope that it will be useful,
dnl  but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl  GNU General Public License for more details.
dnl
dnl  You should have received a copy of the GNU General Public License
dnl  along with this program; if not, write to the Free Software
dnl  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
dnl  USA, or send email to serl@cs.colorado.edu.
dnl
dnl $Id: experiment.m4,v 1.1 2007-07-10 13:08:11 wolf Exp $
dnl
dnl ===================== Experiment ======================
dnl
WVL_SYS_Experiment(`Exp0', `MyWorkload', `D0, D1, D2', `Bed0', `Siena', `CHMap0, CHMap1, CHMap2')dnl
dnl
dnl ===================== Workload ======================
dnl
WVL_SYS_Workload(`MyWorkload', `MyWorkload.wkld', `C1, C2, C3')dnl
dnl
dnl ===================== Testbed Conceptual Model Configuration ====================
dnl
dnl -- TestBed --
dnl
WVL_SYS_Testbed( `Bed0', `Local', `H0, H1, H2', `', `')dnl
dnl
dnl -- Host --
dnl
WVL_SYS_Host(`H0', `skagen.cs.colorado.edu', `ywang', `/bin/sh', `/opt/sun-jdk-1.4.2.06/bin/java', `/scratch/weevil/skagentestroot', `Linux')dnl
WVL_SYS_Host(`H1', `canto.cs.colorado.edu', `ywang', `/bin/sh', `/usr/local/linux-sun-jdk1.4.1/bin/java', `/scratch/weevil/cantotestroot', `FreeBSD')dnl
WVL_SYS_Host(`H2', `skylark.cs.colorado.edu', `ywang', `/bin/sh', `/usr/local/linux-sun-jdk1.4.1/bin/java', `/scratch/weevil/cavallotestroot', `FreeBSD')dnl
dnl
dnl -- HostType --
dnl
WVL_SYS_HostType(`FreeBSD')dnl
WVL_SYS_HostType(`Linux')dnl
dnl
dnl -- HostProp --
dnl
dnl
dnl ======================= SUE Conceptual Model Configuration =======================
dnl
dnl -- SUE --
dnl
WVL_SYS_SUE( `Siena', `S0, S1, S2', `R10, R20', `Order')dnl
dnl
dnl -- ComponentType --
dnl
WVL_SYS_ComponentType(`SienaServer', `SienaServer_startScript', `SienaServer_stopScript', `', dnl
`theCompPath/WVL_SYS_Echo(WVL_Experiment_Name)`_'WVL_Component_ID.log, dnl
theCompPath/WVL_SYS_Echo(WVL_Experiment_Name)`_'WVL_Component_ID.err')dnl
dnl
dnl - SienaServer Start/Stop Script -
dnl
define(`SienaServer_startScript', dnl
`WVL_SYS_Echo(`WVL_Host_'WVL_SYS_Echo(theHost)`_java') -classpath dnl
theSoftwarePath/siena-1.5.1.jar dnl
siena.StartServer -id WVL_Component_ID -WVL_SYS_Echo(`WVL_Component_'WVL_Component_ID`_Protocol') \
-port WVL_SYS_Echo(`WVL_Component_'WVL_Component_ID`_Port') \
ifdef(`WVL_ComponentRelation_'WVL_Component_ID`_Parent', `define(`theParent', `WVL_ComponentRelation_'WVL_Component_ID`_Parent')dnl
 -master WVL_SYS_Echo(`WVL_Component_'WVL_SYS_Echo(theParent)`_Protocol'):`'dnl
WVL_SYS_Echo(`WVL_Host_'WVL_SYS_Echo(`WVL_ComponentHost_'WVL_SYS_Echo(theParent)`_host')`_address'):`'dnl
WVL_SYS_Echo(`WVL_Component_'WVL_SYS_Echo(theParent)`_Port')') \
 -log theCompPath/WVL_SYS_Echo(WVL_Experiment_Name)`_'WVL_Component_ID.log -err theCompPath/WVL_SYS_Echo(WVL_Experiment_Name)`_'WVL_Component_ID.err &')dnl
dnl
define(`SienaServer_stopScript', dnl
`read pid <theCompPath/WVL_SYS_Echo(WVL_Experiment_Name)`_'WVL_Component_ID.pid
echo $pid
kill $pid')dnl
dnl
dnl -- Component --
dnl
WVL_SYS_Component(`S0', `SienaServer')dnl
WVL_SYS_Component(`S1', `SienaServer')dnl
WVL_SYS_Component(`S2', `SienaServer')dnl
dnl
dnl -- ComponentProp --
dnl
WVL_SYS_ComponentProp(`S0', `Port', 4321)dnl
WVL_SYS_ComponentProp(`S1', `Port', 5432)dnl
WVL_SYS_ComponentProp(`S2', `Port', 6543)dnl
WVL_SYS_ComponentProp(`S0', `Protocol', `ka')dnl
WVL_SYS_ComponentProp(`S1', `Protocol', `ka')dnl
WVL_SYS_ComponentProp(`S2', `Protocol', `ka')dnl
dnl
dnl -- ComponentRelation --
dnl
WVL_SYS_ComponentRelation(`R10', `Parent', `S1', `S0')dnl
WVL_SYS_ComponentRelation(`R20', `Parent', `S2', `S0')dnl
dnl
dnl -- ComponentOrder --
dnl
WVL_SYS_ComponentOrder(`Order', `S0, 3, S1, 0, S2, 0')dnl
dnl
dnl ===================== Mappings(SUE-Testbed) ====================
dnl
dnl -- ComponentHost --
dnl
WVL_SYS_ComponentHost(`CHMap0', `S0', `H0')dnl
WVL_SYS_ComponentHost(`CHMap1', `S1', `H1')dnl
WVL_SYS_ComponentHost(`CHMap2', `S2', `H2')dnl
dnl
dnl -- ComponentHostType --
dnl
WVL_SYS_ComponentHostType( `SienaServer', `FreeBSD', `/scratch/software/Siena')dnl
WVL_SYS_ComponentHostType( `SienaServer', `Linux', `/scratch/software/Siena')dnl
dnl
dnl ===================== Mappings(SUE-Actor) ====================
dnl
dnl -- ActorProgram --
dnl
WVL_SYS_ActorProgram(`DrProgram1', `Java', `./actor', `SienaActor', `SienaActor_args', `SienaActor_classpath')dnl
dnl
define(`SienaActor_args', `WVL_SYS_Echo(`WVL_Component_'theComponent`_Protocol') dnl
WVL_SYS_Echo(`WVL_Host_'theHost`_address') WVL_SYS_Echo(`WVL_Component_'theComponent`_Port') dnl
WVL_SYS_Echo(`WVL_Actor_'WVL_Actor_ID`_Port')')dnl
dnl
define(`SienaActor_classpath', `theSoftwarePath/siena-1.5.1.jar')dnl
dnl
dnl -- Actor --
dnl
WVL_SYS_Actor(`D0', `C1', `DrProgram1', `S2')dnl
WVL_SYS_Actor(`D1', `C2', `DrProgram1', `S0')dnl
WVL_SYS_Actor(`D2', `C3', `DrProgram1', `S1')dnl
dnl
dnl
dnl -- ActorProp --
dnl
WVL_SYS_ActorProp(`D0', `Port', `4322')dnl
WVL_SYS_ActorProp(`D1', `Port', `5433')dnl
WVL_SYS_ActorProp(`D2', `Port', `6544')dnl
dnl
